"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutPropertiesLoose"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _SafeAnchor = _interopRequireDefault(require("../SafeAnchor"));

var _utils = require("../utils");

var BreadcrumbItem = /*#__PURE__*/_react.default.forwardRef(function (props, ref) {
  var _props$as = props.as,
      Component = _props$as === void 0 ? _SafeAnchor.default : _props$as,
      href = props.href,
      _props$classPrefix = props.classPrefix,
      classPrefix = _props$classPrefix === void 0 ? 'breadcrumb-item' : _props$classPrefix,
      title = props.title,
      target = props.target,
      className = props.className,
      style = props.style,
      active = props.active,
      children = props.children,
      rest = (0, _objectWithoutPropertiesLoose2.default)(props, ["as", "href", "classPrefix", "title", "target", "className", "style", "active", "children"]);

  var _useClassNames = (0, _utils.useClassNames)(classPrefix),
      merge = _useClassNames.merge,
      withClassPrefix = _useClassNames.withClassPrefix;

  var classes = merge(className, withClassPrefix({
    active: active
  }));

  if (active) {
    return /*#__PURE__*/_react.default.createElement("span", (0, _extends2.default)({
      ref: ref
    }, rest, {
      style: style,
      className: classes
    }), children);
  }

  return /*#__PURE__*/_react.default.createElement(Component, (0, _extends2.default)({}, rest, {
    href: href,
    title: title,
    target: target,
    ref: ref,
    style: style,
    className: classes
  }), children);
});

BreadcrumbItem.displayName = 'BreadcrumbItem';
BreadcrumbItem.propTypes = {
  active: _propTypes.default.bool,
  className: _propTypes.default.string,
  style: _propTypes.default.object,
  href: _propTypes.default.string,
  title: _propTypes.default.string,
  target: _propTypes.default.string,
  classPrefix: _propTypes.default.string,
  as: _propTypes.default.elementType
};
var _default = BreadcrumbItem;
exports.default = _default;