"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutPropertiesLoose"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _utils = require("../utils");

var _CalendarContext = require("./CalendarContext");

var weekKeys = ['sunday', 'monday', 'tuesday', 'wednesday', 'thursday', 'friday', 'saturday'];

var TableHeaderRow = /*#__PURE__*/_react.default.forwardRef(function (props, ref) {
  var _props$as = props.as,
      Component = _props$as === void 0 ? 'div' : _props$as,
      className = props.className,
      _props$classPrefix = props.classPrefix,
      classPrefix = _props$classPrefix === void 0 ? 'calendar-table' : _props$classPrefix,
      rest = (0, _objectWithoutPropertiesLoose2.default)(props, ["as", "className", "classPrefix"]);

  var _useCalendarContext = (0, _CalendarContext.useCalendarContext)(),
      locale = _useCalendarContext.locale,
      showWeekNumbers = _useCalendarContext.showWeekNumbers,
      isoWeek = _useCalendarContext.isoWeek;

  var _useClassNames = (0, _utils.useClassNames)(classPrefix),
      merge = _useClassNames.merge,
      prefix = _useClassNames.prefix;

  var classes = merge(className, prefix('row', 'header-row'));
  var items = weekKeys;

  if (isoWeek) {
    items = weekKeys.filter(function (v) {
      return v !== 'sunday';
    });
    items.push('sunday');
  }

  return /*#__PURE__*/_react.default.createElement(Component, (0, _extends2.default)({
    role: "row"
  }, rest, {
    ref: ref,
    className: classes
  }), showWeekNumbers && /*#__PURE__*/_react.default.createElement("div", {
    className: prefix('cell'),
    role: "columnheader"
  }), items.map(function (key) {
    return /*#__PURE__*/_react.default.createElement("div", {
      key: key,
      className: prefix('cell'),
      role: "columnheader"
    }, /*#__PURE__*/_react.default.createElement("span", {
      className: prefix('cell-content')
    }, locale === null || locale === void 0 ? void 0 : locale[key]));
  }));
});

TableHeaderRow.displayName = 'TableHeaderRow';
TableHeaderRow.propTypes = {
  as: _propTypes.default.elementType,
  className: _propTypes.default.string,
  classPrefix: _propTypes.default.string
};
var _default = TableHeaderRow;
exports.default = _default;