import React, { Ref } from 'react';
import { PickerLocale } from '../locales';
import { PickerInstance, PickerToggleProps } from '../Picker';
import { ItemDataType, FormControlPickerProps } from '../@types/common';
import type { MultipleSelectProps } from '../SelectPicker';
export declare type ValueType = (number | string)[];
export interface CheckPickerProps<T> extends FormControlPickerProps<T[], PickerLocale, ItemDataType<T>>, MultipleSelectProps<T>, Pick<PickerToggleProps, 'label'> {
    /** Top the selected option in the options */
    sticky?: boolean;
    /** A picker that can be counted */
    countable?: boolean;
}
export interface CheckPickerComponent {
    <T>(props: CheckPickerProps<T> & {
        ref?: Ref<PickerInstance>;
    }): JSX.Element | null;
    displayName?: string;
    propTypes?: React.WeakValidationMap<CheckPickerProps<any>>;
}
declare const CheckPicker: CheckPickerComponent;
export default CheckPicker;
