import React from 'react';
import { CalendarProps as CalendarCoreProps } from '../Calendar/Calendar';
import { DateRange } from './types';
import { RsRefForwardingComponent, WithAsProps } from '../@types/common';
import { DatePickerLocale } from '../locales';
import { DATERANGE_DISABLED_TARGET } from '../utils';
declare type OmitCalendarCoreTypes = 'disabledDate' | 'onSelect' | 'onMouseMove' | 'calendarDate' | 'format' | 'locale' | 'onToggleMeridian';
export interface CalendarProps extends WithAsProps, Omit<CalendarCoreProps, OmitCalendarCoreTypes> {
    calendarDate?: DateRange;
    disabledDate?: (date: Date, selectValue: [] | [Date] | [Date, Date], type: DATERANGE_DISABLED_TARGET) => boolean;
    format?: string;
    hoverRangeValue?: DateRange;
    index: number;
    isoWeek?: boolean;
    limitEndYear?: number;
    locale?: DatePickerLocale;
    onChangeCalendarDate?: (index: number, date: Date) => void;
    onChangeCalendarTime?: (index: number, date: Date) => void;
    onToggleMeridian: (index: number, event: React.MouseEvent) => void;
    onMouseMove?: (date: Date) => void;
    onSelect?: (date: Date, event: React.SyntheticEvent) => void;
    showOneCalendar?: boolean;
    showWeekNumbers?: boolean;
    value?: [] | [Date] | [Date, Date];
}
declare const Calendar: RsRefForwardingComponent<'div', CalendarProps>;
export default Calendar;
