import PropTypes from 'prop-types';
export declare const pickerPropTypes: {
    classPrefix: PropTypes.Requireable<string>;
    className: PropTypes.Requireable<string>;
    style: PropTypes.Requireable<object>;
    locale: PropTypes.Requireable<any>;
    appearance: PropTypes.Requireable<string>;
    block: PropTypes.Requireable<boolean>;
    containerPadding: PropTypes.Requireable<number>;
    container: PropTypes.Requireable<any>;
    disabled: PropTypes.Requireable<boolean>;
    menuClassName: PropTypes.Requireable<string>;
    menuStyle: PropTypes.Requireable<object>;
    placeholder: PropTypes.Requireable<PropTypes.ReactNodeLike>;
    placement: PropTypes.Requireable<"top" | "bottom" | "right" | "left" | "bottomStart" | "bottomEnd" | "topStart" | "topEnd" | "leftStart" | "rightStart" | "leftEnd" | "rightEnd" | "auto" | "autoVertical" | "autoVerticalStart" | "autoVerticalEnd" | "autoHorizontal" | "autoHorizontalStart" | "autoHorizontalEnd">;
    /**
     * Prevent floating element overflow
     */
    preventOverflow: PropTypes.Requireable<boolean>;
    open: PropTypes.Requireable<boolean>;
    defaultOpen: PropTypes.Requireable<boolean>;
    cleanable: PropTypes.Requireable<boolean>;
    renderExtraFooter: PropTypes.Requireable<(...args: any[]) => any>;
    renderValue: PropTypes.Requireable<(...args: any[]) => any>;
    onOpen: PropTypes.Requireable<(...args: any[]) => any>;
    onClose: PropTypes.Requireable<(...args: any[]) => any>;
    onClean: PropTypes.Requireable<(...args: any[]) => any>;
    listProps: PropTypes.Requireable<any>;
    onEnter: PropTypes.Requireable<(...args: any[]) => any>;
    onEntering: PropTypes.Requireable<(...args: any[]) => any>;
    onEntered: PropTypes.Requireable<(...args: any[]) => any>;
    onExit: PropTypes.Requireable<(...args: any[]) => any>;
    onExiting: PropTypes.Requireable<(...args: any[]) => any>;
    onExited: PropTypes.Requireable<(...args: any[]) => any>;
};
export declare const listPickerPropTypes: {
    data: PropTypes.Validator<any[]>;
    valueKey: PropTypes.Requireable<string>;
    labelKey: PropTypes.Requireable<string>;
    childrenKey: PropTypes.Requireable<string>;
    disabledItemValues: PropTypes.Requireable<any[]>;
    value: PropTypes.Requireable<any>;
    defaultValue: PropTypes.Requireable<any>;
    onChange: PropTypes.Requireable<(...args: any[]) => any>;
    classPrefix: PropTypes.Requireable<string>;
    className: PropTypes.Requireable<string>;
    style: PropTypes.Requireable<object>;
    locale: PropTypes.Requireable<any>;
    appearance: PropTypes.Requireable<string>;
    block: PropTypes.Requireable<boolean>;
    containerPadding: PropTypes.Requireable<number>;
    container: PropTypes.Requireable<any>;
    disabled: PropTypes.Requireable<boolean>;
    menuClassName: PropTypes.Requireable<string>;
    menuStyle: PropTypes.Requireable<object>;
    placeholder: PropTypes.Requireable<PropTypes.ReactNodeLike>;
    placement: PropTypes.Requireable<"top" | "bottom" | "right" | "left" | "bottomStart" | "bottomEnd" | "topStart" | "topEnd" | "leftStart" | "rightStart" | "leftEnd" | "rightEnd" | "auto" | "autoVertical" | "autoVerticalStart" | "autoVerticalEnd" | "autoHorizontal" | "autoHorizontalStart" | "autoHorizontalEnd">;
    /**
     * Prevent floating element overflow
     */
    preventOverflow: PropTypes.Requireable<boolean>;
    open: PropTypes.Requireable<boolean>;
    defaultOpen: PropTypes.Requireable<boolean>;
    cleanable: PropTypes.Requireable<boolean>;
    renderExtraFooter: PropTypes.Requireable<(...args: any[]) => any>;
    renderValue: PropTypes.Requireable<(...args: any[]) => any>;
    onOpen: PropTypes.Requireable<(...args: any[]) => any>;
    onClose: PropTypes.Requireable<(...args: any[]) => any>;
    onClean: PropTypes.Requireable<(...args: any[]) => any>;
    listProps: PropTypes.Requireable<any>;
    onEnter: PropTypes.Requireable<(...args: any[]) => any>;
    onEntering: PropTypes.Requireable<(...args: any[]) => any>;
    onEntered: PropTypes.Requireable<(...args: any[]) => any>;
    onExit: PropTypes.Requireable<(...args: any[]) => any>;
    onExiting: PropTypes.Requireable<(...args: any[]) => any>;
    onExited: PropTypes.Requireable<(...args: any[]) => any>;
};
