import React from 'react';
import { WithAsProps, RsRefForwardingComponent } from '../@types/common';
export interface TreeNodeProps extends WithAsProps {
    rtl?: boolean;
    layer: number;
    value?: any;
    label?: any;
    focus?: boolean;
    loading?: boolean;
    expand?: boolean;
    active?: boolean;
    visible: boolean;
    nodeData: any;
    disabled?: boolean;
    draggable?: boolean;
    dragging?: boolean;
    dragOver?: boolean;
    dragOverTop?: boolean;
    dragOverBottom?: boolean;
    hasChildren?: boolean;
    className?: string;
    classPrefix?: string;
    style?: React.CSSProperties;
    onExpand?: (nodeData: any) => void;
    onSelect?: (nodeData: any, event: React.SyntheticEvent) => void;
    onRenderTreeIcon?: (nodeData: any) => React.ReactNode;
    onRenderTreeNode?: (nodeData: any) => React.ReactNode;
    onDragStart?: (data: any, event: React.DragEvent<any>) => void;
    onDragEnter?: (data: any, event: React.DragEvent<any>) => void;
    onDragOver?: (data: any, event: React.DragEvent<any>) => void;
    onDragLeave?: (data: any, event: React.DragEvent<any>) => void;
    onDragEnd?: (data: any, event: React.DragEvent<any>) => void;
    onDrop?: (data: any, event: React.DragEvent<any>) => void;
}
declare const TreeNode: RsRefForwardingComponent<'div', TreeNodeProps>;
export default TreeNode;
