import React from 'react';
import { PickerLocale } from '../locales';
import { PickerComponent } from '../Picker';
import { TreeDragProps, TreeBaseProps } from '../Tree/Tree';
import { FormControlPickerProps, ItemDataType } from '../@types/common';
export declare const maxTreeHeight = 320;
export interface TreePickerProps<T = number | string> extends TreeBaseProps<T, ItemDataType>, TreeDragProps, FormControlPickerProps<T, PickerLocale, ItemDataType> {
    /** The height of Dropdown */
    height?: number;
    /** Tree node cascade */
    cascade?: boolean;
    /** A picker that can be counted */
    countable?: boolean;
    /** Whether display search input box */
    searchable?: boolean;
    /** Whether using virtualized list */
    virtualized?: boolean;
    /** Set the option value for the expand node */
    defaultExpandItemValues?: ItemDataType[];
    /** Set the option value for the expand node with controlled*/
    expandItemValues?: ItemDataType[];
    /** Custom render selected items */
    renderValue?: (value: T, selectedItems: ItemDataType, selectedElement: React.ReactNode) => React.ReactNode;
    /** Called when scrolling */
    onScroll?: (event: React.SyntheticEvent) => void;
}
declare const TreePicker: PickerComponent<TreePickerProps>;
export default TreePicker;
