"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutPropertiesLoose"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _OverlayTrigger = _interopRequireDefault(require("../Overlay/OverlayTrigger"));

var _utils = require("../utils");

var _CustomProvider = require("../CustomProvider");

var Whisper = /*#__PURE__*/_react.default.forwardRef(function (props, ref) {
  var onOpen = props.onOpen,
      onClose = props.onClose,
      onEntered = props.onEntered,
      onExited = props.onExited,
      _props$placement = props.placement,
      placement = _props$placement === void 0 ? 'right' : _props$placement,
      preventOverflow = props.preventOverflow,
      rest = (0, _objectWithoutPropertiesLoose2.default)(props, ["onOpen", "onClose", "onEntered", "onExited", "placement", "preventOverflow"]);
  return /*#__PURE__*/_react.default.createElement(_CustomProvider.CustomConsumer, null, function (context) {
    return /*#__PURE__*/_react.default.createElement(_OverlayTrigger.default, (0, _extends2.default)({}, rest, {
      ref: ref,
      preventOverflow: preventOverflow,
      placement: (0, _utils.placementPolyfill)(placement, context === null || context === void 0 ? void 0 : context.rtl),
      onEntered: (0, _utils.createChainedFunction)(onOpen, onEntered),
      onExited: (0, _utils.createChainedFunction)(onClose, onExited)
    }));
  });
});

Whisper.displayName = 'Whisper';
Whisper.propTypes = {
  onOpen: _propTypes.default.func,
  onClose: _propTypes.default.func,
  onEntered: _propTypes.default.func,
  onExited: _propTypes.default.func,
  placement: _propTypes.default.oneOf(_utils.PLACEMENT),

  /**
   * Prevent floating element overflow
   */
  preventOverflow: _propTypes.default.bool,

  /**
   * Whether enable speaker follow cursor
   */
  followCursor: _propTypes.default.bool
};
var _default = Whisper;
exports.default = _default;