declare const _default: {
    common: {
        loading: string;
        emptyMessage: string;
    };
    Plaintext: {
        unfilled: string;
        notSelected: string;
        notUploaded: string;
    };
    Pagination: {
        more: string;
        prev: string;
        next: string;
        first: string;
        last: string;
        limit: string;
        total: string;
        skip: string;
    };
    Calendar: {
        sunday: string;
        monday: string;
        tuesday: string;
        wednesday: string;
        thursday: string;
        friday: string;
        saturday: string;
        ok: string;
        today: string;
        yesterday: string;
        hours: string;
        minutes: string;
        seconds: string;
        /**
         * Format of the string is based on Unicode Technical Standard #35:
         * https://www.unicode.org/reports/tr35/tr35-dates.html#Date_Field_Symbol_Table
         **/
        formattedMonthPattern: string;
        formattedDayPattern: string;
        dateLocale: any;
    };
    DatePicker: {
        sunday: string;
        monday: string;
        tuesday: string;
        wednesday: string;
        thursday: string;
        friday: string;
        saturday: string;
        ok: string;
        today: string;
        yesterday: string;
        hours: string;
        minutes: string;
        seconds: string;
        /**
         * Format of the string is based on Unicode Technical Standard #35:
         * https://www.unicode.org/reports/tr35/tr35-dates.html#Date_Field_Symbol_Table
         **/
        formattedMonthPattern: string;
        formattedDayPattern: string;
        dateLocale: any;
    };
    DateRangePicker: {
        last7Days: string;
        sunday: string;
        monday: string;
        tuesday: string;
        wednesday: string;
        thursday: string;
        friday: string;
        saturday: string;
        ok: string;
        today: string;
        yesterday: string;
        hours: string;
        minutes: string;
        seconds: string;
        /**
         * Format of the string is based on Unicode Technical Standard #35:
         * https://www.unicode.org/reports/tr35/tr35-dates.html#Date_Field_Symbol_Table
         **/
        formattedMonthPattern: string;
        formattedDayPattern: string;
        dateLocale: any;
    };
    Picker: {
        noResultsText: string;
        placeholder: string;
        searchPlaceholder: string;
        checkAll: string;
        loading: string;
    };
    Input: {
        emptyPlaintext: string;
    };
    InputPicker: {
        newItem: string;
        createOption: string;
    };
    Uploader: {
        inited: string;
        progress: string;
        error: string;
        complete: string;
        emptyFile: string;
        upload: string;
    };
    CloseButton: {
        closeLabel: string;
    };
    Breadcrumb: {
        expandText: string;
    };
    Toggle: {
        on: string;
        off: string;
    };
};
export default _default;
