import defaultLocale from './default';
export { default as arEG } from './ar_EG';
export { default as daDK } from './da_DK';
export { default as deDE } from './de_DE';
export { default as enGB } from './en_GB';
export { default as enUS } from './en_US';
export { default as esAR } from './es_AR';
export { default as esES } from './es_ES';
export { default as fiFI } from './fi_FI';
export { default as itIT } from './it_IT';
export { default as koKR } from './ko_KR';
export { default as ptBR } from './pt_BR';
export { default as ruRU } from './ru_RU';
export { default as svSE } from './sv_SE';
export { default as zhCN } from './zh_CN';
export { default as zhTw } from './zh_TW';
export { default as faIR } from './fa_IR';
declare type PickKeys<T> = {
    [keys in keyof T]?: T[keys];
};
export declare type Locale = PickKeys<typeof defaultLocale>;
export declare type CommonLocale = typeof defaultLocale.common;
export declare type CalendarLocale = PickKeys<typeof defaultLocale.Calendar>;
export declare type PlaintextLocale = PickKeys<typeof defaultLocale.Plaintext>;
export declare type PaginationLocale = PickKeys<typeof defaultLocale.Pagination>;
export declare type TableLocale = CommonLocale;
export declare type DatePickerLocale = PickKeys<typeof defaultLocale.DatePicker>;
export declare type DateRangePickerLocale = PickKeys<typeof defaultLocale.DateRangePicker>;
export declare type PickerLocale = typeof defaultLocale.Picker & CommonLocale;
export declare type InputPickerLocale = PickerLocale & typeof defaultLocale.InputPicker;
export declare type UploaderLocale = PickKeys<typeof defaultLocale.Uploader>;
export declare type CloseButtonLocale = PickKeys<typeof defaultLocale.CloseButton>;
export declare type BreadcrumbLocale = PickKeys<typeof defaultLocale.Breadcrumb>;
export declare type ToggleLocale = PickKeys<typeof defaultLocale.Toggle>;
