import React from 'react';
import { ToastContainerProps } from './ToastContainer';
export interface Toaster {
    /**
     * Add a message to the container.
     * When the container does not exist, create a new container. Use `placement` as the ID of the container
     * @param message
     * @param options
     */
    push(message: React.ReactNode, options?: ToastContainerProps): string | undefined;
    /**
     * Remove a message by key
     * @param key
     */
    remove(key: string): void;
    /**
     * Clear all messages
     */
    clear(): void;
}
declare const toaster: Toaster;
export default toaster;
